.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/sis/sis.man,v 1.6 2002/01/10 19:05:43 eich Exp $ 
.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH SIS __drivermansuffix__ __vendorversion__
.SH NAME
sis \- SiS video driver
.SH SYNOPSIS
.nf
.B "Section \*qDevice\*q"
.BI "  Identifier \*q"  devname \*q
.B  "  Driver \*qsis\*q"
\ \ ...
.B EndSection
.fi
.SH DESCRIPTION
.B sis 
is an XFree86 driver for SiS video cards. The driver is accelerated, and
provides support for 8, 16 and 24 colordepths. XVideo, Render and other
extensions are supported as well.
.SH SUPPORTED HARDWARE
The
.B sis
driver supports PCI and AGP video cards based on the following chipsets:
.PP
.B SIS5597
.B SIS5598
.B SIS530
.B SIS6326
.B SIS300
.B SIS540
.B SIS630
.SH CONFIGURATION DETAILS
Please refer to XF86Config(__filemansuffix__) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The driver will auto-detect the amount of video memory present for all
chips, but in the 6326 case, it will limit the memory size to 4MB. This
is because of a bug (in docs at least). You can override this using the
.B \*qVideoRAM\*q
option in the device section if your board has more than
4MB and you need to use it (maybe with cursor problems).
.PP
If you have problems getting high resolutions because of dot clock
limitations, try using the
.B \*qDacSpeed\*q
option, also in the device section.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option \*qNoAccel\*q \*q" boolean \*q
Disable or enable acceleration. Default: acceleration is enabled.
.TP
.BI "Option \*qHWCursor\*q \*q" boolean \*q
Enable or disable the HW cursor. Default: on.
.TP
.BI "Option \*qSWCursor\*q \*q" boolean \*q
The opposite of HWCursor. Default: off.
.TP
.BI "Option \*qNoXVideo*q \*q" boolean \*q
Disable XV (XVideo) extension support. Default: off.
.TP
.BI "Option \*qSetMClk\*q \*q" integer \*q
Set the memory clock. Value in MHz. Default: autodetect.
.TP
.BI "Option \*qPciRetry\*q \*q" boolean \*q
Enable or disable PCI retries.  Default: on.
.TP
.BI "Option \*qTurboQueue\*q \*q" boolean \*q
Enable or disable TurboQueue mode.  Default: off for SIS530, on for the
others
.TP
.BI "Option \*qFastVram\*q \*q" boolean \*q
Enable or disable FastVram mode.  Default: on.
.TP
.BI "Option \*qRotate\*q \*qCW\*q"
Rotate the display clockwise. This mode is unaccelerated, and uses 
the Shadow Frame Buffer layer.
Default: no rotation.
.TP
.BI "Option \*qRotate\*q \*qCCW\*q"
Rotate the display counterclockwise. This mode is unaccelerated, and
uses the Shadow Frame Buffer layer.
Default: no rotation.
.TP
.BI "Option \*qForceCRT2Type\*q \*qstring\*q"
Force display type to one of: TV, LCD or VGA. Default: auto detect.
.TP
.BI "Option \*qShadowFB\*q \*q" boolean \*q
Enable or disable use of the shadow framebuffer layer. Default: off.
.TP
.BI "Option \*qNoXVideo\*q \*q" boolean \*q
Enable or disable use of the video scaler. Default: off.
.TP
.BI "Option \*qVESA\*q \*q" boolean \*q
Force use of VESA BIOS initialization on or off. 
Default: If option is not set: chipset dependent.
.TP
.BI "Option \*qMaxXFBMem\*q \*q" integer \*q
Amount of video memory to use for X. This option is useful to reserve
some memory from the top of the video memory for 3D. Under Linux 3D 
memory is currently handled by the sisfb kernel driver. 
Default: use all video memory for X.
.SH "SEE ALSO"
XFree86(1), XF86Config(__filemansuffix__), xf86config(1), Xserver(1), X(__miscmansuffix__)
.SH AUTHORS
Authors include: Alan Hourihane, Mike Chapman, Juanjo Santamarta, Mitani
Hiroshi, David Thomas, Sung-Ching Lin, Ademar Reis
